
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>TF-IDF算法及其编程实现 / 憋错料</title>

    <meta name="description" content="TF-IDF算法及其编程实现 概念 TF-IDF(term frequency–inverse document frequency)是一种用于资讯检索与资讯探勘的常用加权技术.TF-IDF是一种统计方法,用以评估一字词对于一个文件集或一个语料库中的其中一份文件的重要程度.字词的重要性随着它在文件中出现的次数成正比增加,但同时会随着它在语料库中出现的频率成反比下降.TF-IDF加权的各种形式常被搜寻引擎应用,作为文件与用户查询之间相关程度的度量或评级.除了TF-IDF以外,因特网上的搜寻引擎还会使用基于连结分析的评级方法,以">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">TF-IDF算法及其编程实现</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p><strong>概念</strong></p>
<p>TF-IDF（term frequency–inverse document frequency）是一种用于资讯检索与资讯探勘的常用加权技术。TF-IDF是一种统计方法，用以评估一字词对于一个文件集或一个语料库中的其中一份文件的重要程度。字词的重要性随着它在文件中出现的次数成正比增加，但同时会随着它在语料库中出现的频率成反比下降。TF-IDF加权的各种形式常被搜寻引擎应用，作为文件与用户查询之间相关程度的度量或评级。除了TF-IDF以外，因特网上的搜寻引擎还会使用基于连结分析的评级方法，以确定文件在搜寻结果中出现的顺序。</p>
<p>　　</p>
<p><strong>原理</strong></p>
<p>在一份给定的文件里，<strong>词频 (term frequency, TF)</strong>&nbsp;指的是某一个给定的词语在该文件中出现的次数。这个数字通常会被归一化（分子一般小于分母 区别于IDF），以防止它偏向长的文件。（同一个词语在长文件里可能会比短文件有更高的词频，而不管该词语重要与否。）</p>
<p>　　<strong>逆向文件频率 (inverse document frequency, IDF)</strong>&nbsp;是一个词语普遍重要性的度量。某一特定词语的IDF，可以由总文件数目除以包含该词语之文件的数目，再将得到的商取对数得到。</p>
<p>　　某一特定文件内的高词语频率，以及该词语在整个文件集合中的低文件频率，可以产生出高权重的TF-IDF。因此，TF-IDF倾向于过滤掉常见的词语，保留重要的词语。</p>
<p><strong>TFIDF的主要思想是</strong>：如果某个词或短语在一篇文章中出现的频率TF高，并且在其他文章中很少出现，则认为此词或者短语具有很好的类别区分能力，适合用来分类。TFIDF实际上是：TF * IDF，TF词频(Term Frequency)，IDF反文档频率(Inverse Document<br />
 Frequency)。<strong>TF</strong>表示词条在文档d中出现的频率（另一说：<strong>TF词频(Term Frequency)指</strong>的是某一个给定的词语在该文件中出现的次数）。IDF的主要思想是：如果包含词条t的文档越少，也就是n越小，IDF越大，则说明词条t具有很好的类别区分能力。如果某一类文档C中包含词条t的文档数为m，而其它类包含t的文档总数为k，显然所有包含t的文档数n=m&#043;k，当m大的时候，n也大，按照IDF公式得到的IDF的&#20540;会小，就说明该词条t类别区分能力不强。（另一说：<strong>IDF反文档频率(Inverse<br />
 Document Frequency)</strong>是指果包含词条的文档越少，IDF越大，则说明词条具有很好的类别区分能力。）但是实际上，如果一个词条在一个类的文档中频繁出现，则说明该词条能够很好代表这个类的文本的特征，这样的词条应该给它们赋予较高的权重，并选来作为该类文本的特征词以区别与其它类文档。这就是IDF的不足之处.</p>
<p>在一份给定的文件里，<strong>词频</strong>（term frequency，TF）指的是某一个给定的词语在该文件中出现的频率。这个数字是对<strong>词数</strong>(term count)的归一化，以防止它偏向长的文件。（同一个词语在长文件里可能会比短文件有更高的词数，而不管该词语重要与否。）对于在某一特定文件里的词语 ti&nbsp;来说，它的重要性可表示为：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA5MjcxNjIyMTEyOTU/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2Y0hWeGRYUnZaMlYwYUdWeS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L1NvdXRoRWFzdA==.jpg"></p>
<p>以上式子中 nij是该词在文件dj中的出现次数，而分母则是在文件dj中所有字词的出现次数之和。</p>
<p><strong>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;逆向文件频率</strong>（inverse document frequency，IDF）是一个词语普遍重要性的度量。某一特定词语的IDF，可以由总文件数目除以包含该词语之文件的数目，再将得到的商取对数得到：</p>
<dl>
<dd><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA5MjcxNjIzMTIxNTE/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2Y0hWeGRYUnZaMlYwYUdWeS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L1NvdXRoRWFzdA==.jpg">
</dd>
</dl>
<p>其中</p>
<ul>
<li>|D|：语料库中的文件总数</li>
<li><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA5MjcxNjI1MTQyMDY/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2Y0hWeGRYUnZaMlYwYUdWeS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L1NvdXRoRWFzdA==.jpg">包含词语的文件数目（即nij!=0的文件数目）如果该词语不在语料库中，就会导致被除数为零，<strong>因此一般情况下使用<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA5MjcxNjI1MzgxMjE/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2Y0hWeGRYUnZaMlYwYUdWeS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L1NvdXRoRWFzdA==.jpg"></strong></li>
</ul>
<p>然后</p>
<dl>
<dd><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA5MjcxNjI0Mzc1NDY/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2Y0hWeGRYUnZaMlYwYUdWeS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L1NvdXRoRWFzdA==.jpg">
</dd>
</dl>
<p>某一特定文件内的高词语频率，以及该词语在整个文件集合中的低文件频率，可以产生出高权重的TF-IDF。因此，TF-IDF倾向于过滤掉常见的词语，保留重要的词语。</p>
<p><strong>示例</strong></p>
<p>一：有很多不同的数学公式可以用来计算TF-IDF。这边的例子以上述的数学公式来计算。词频 (TF) 是一词语出现的次数除以该文件的总词语数。假如一篇文件的总词语数是100个，而词语“母牛”出现了3次，那么“母牛”一词在该文件中的词频就是3/100=0.03。一个计算文件频率 (DF) 的方法是测定有多少份文件出现过“母牛”一词，然后除以文件集里包含的文件总数。所以，如果“母牛”一词在1,000份文件出现过，而文件总数是10,000,000份的话，其逆向文件频率就是<br />
 log(10,000,000 / 1,000)=4。最后的TF-IDF的分数为0.03 * 4=0.12。</p>
<p>二：根据关键字k1,k2,k3进行搜索结果的相关性就变成TF1*IDF1 &#043; TF2*IDF2 &#043; TF3*IDF3。比如document1的term总量为1000，k1,k2,k3在document1出现的次数是100，200，50。包含了 k1, k2, k3的docuement总量分别是 1000， 10000，5000。document<br />
 set的总量为10000。 TF1 = 100/1000 = 0.1 TF2 = 200/1000 = 0.2 TF3 = 50/1000 = 0.05 IDF1 = log(10000/1000) = log(10) = 2.3 IDF2 = log(10000/100000) = log(1) = 0; IDF3 = log(10000/5000) = log(2) = 0.69 这样关键字k1,k2,k3与docuement1的相关性=<br />
 0.1*2.3 &#043; 0.2*0 &#043; 0.05*0.69 = 0.2645 其中k1比k3的比重在document1要大，k2的比重是0.</p>
<p>三：在某个一共有一千词的网页中“原子能”、“的”和“应用”分别出现了 2 次、35 次 和 5 次，那么它们的词频就分别是 0.002、0.035 和 0.005。 我们将这三个数相加，其和 0.042 就是相应网页和查询“原子能的应用”&nbsp;相关性的一个简单的度量。概括地讲，如果一个查询包含关键词<br />
 w1,w2,...,wN, 它们在一篇特定网页中的词频分别是: TF1, TF2, ..., TFN。 （TF: term frequency)。 那么，这个查询和该网页的相关性就是:TF1 &#043; TF2 &#043; ... &#043; TFN。</p>
<p>读者可能已经发现了又一个漏洞。在上面的例子中，词“的”站了总词频的 80% 以上，而它对确定网页的主题几乎没有用。我们称这种词叫“应删除词”（Stopwords)，也就是说在度量相关性是不应考虑它们的频率。在汉语中，应删除词还有“是”、“和”、“中”、“地”、“得”等等几十个。忽略这些应删除词后，上述网页的相&#20284;度就变成了0.007，其中“原子能”贡献了 0.002，“应用”贡献了 0.005。细心的读者可能还会发现另一个小的漏洞。在汉语中，“应用”是个很通用的词，而“原子能”是个很专业的词，后者在相关性排名中比前者重要。因此我们需要给汉语中的每一个词给一个权重，这个权重的设定必须满足下面两个条件：</p>
<p>1. 一个词预测主题能力越强，权重就越大，反之，权重就越小。我们在网页中看到“原子能”这个词，或多或少地能了解网页的主题。我们看到“应用”一次，对主题基本上还是一无所知。因此，“原子能“的权重就应该比应用大。</p>
<p>2. 应删除词的权重应该是零。</p>
<p>我们很容易发现，如果一个关键词只在很少的网页中出现，我们通过它就容易锁定搜索目标，它的权重也就应该大。反之如果一个词在大量网页中出现，我们看到它仍然不很清楚要找什么内容，因此它应该小。概括地讲，假定一个关键词<br />
 ｗ 在 Ｄｗ 个网页中出现过，那么 Ｄｗ 越大，ｗ的权重越小，反之亦然。在信息检索中，使用最多的权重是“逆文本频率指数” （Inverse document frequency 缩写为ＩＤＦ），它的公式为ｌｏｇ（Ｄ／Ｄｗ）其中Ｄ是全部网页数。比如，我们假定中文网页数是Ｄ＝１０亿，应删除词“的”在所有的网页中都出现，即Ｄｗ＝１０亿，那么它的ＩＤＦ＝log(10亿/10亿）= log (1) = ０。假如专用词“原子能”在两百万个网页中出现，即Ｄｗ＝２００万，则它的权重ＩＤＦ＝log(500)<br />
 =6.2。又假定通用词“应用”，出现在五亿个网页中，它的权重ＩＤＦ = log(2)则只有 0.7。也就只说，在网页中找到一个“原子能”的比配相当于找到九个“应用”的匹配。利用 IDF，上述相关性计算个公式就由词频的简单求和变成了加权求和，即 TF1*IDF1 &#043;　TF2*IDF2 ＋... &#043; TFN*IDFN。在上面的例子中，该网页和“原子能的应用”的相关性为 0.0161，其中“原子能”贡献了 0.0126，而“应用”只贡献了0.0035。这个比例和我们的直觉比较一致了。</p>
<p>我使用python编写程序，提取了**问答系统中数据的TF-IDF特征。（其中的文本文件大家可以随意替换为其余文件）</p>
<p><strong>[python]</strong>&nbsp;<a href="http://blog.csdn.net/puqutogether/article/details/39612655#" rel="external nofollow noreferrer">view<br />
 plain</a><a href="http://blog.csdn.net/puqutogether/article/details/39612655#" rel="external nofollow noreferrer">copy</a></p>
<ol>
<li>#&nbsp;This&nbsp;demo&nbsp;can&nbsp;extract&nbsp;the&nbsp;TF-IDF&nbsp;features&nbsp;of&nbsp;each&nbsp;big&nbsp;class&nbsp;data.</li>
<li>#We&nbsp;further&nbsp;use&nbsp;k&nbsp;words&nbsp;&nbsp;corresponding&nbsp;to&nbsp;the&nbsp;k&nbsp;bigges&nbsp;weights&nbsp;as&nbsp;the&nbsp;features&nbsp;set&nbsp;for&nbsp;each&nbsp;big&nbsp;class.</li>
<li>import&nbsp;IndexOfClass&nbsp;&nbsp;#import&nbsp;the&nbsp;IndexOfClass.py,&nbsp;to&nbsp;obtain&nbsp;the&nbsp;row&nbsp;index&nbsp;of&nbsp;each&nbsp;big&nbsp;class&nbsp;in&nbsp;the&nbsp;original&nbsp;Rujia&nbsp;data</li>
<li>import&nbsp;math&nbsp;&nbsp;#&nbsp;the&nbsp;math.log10&nbsp;is&nbsp;in&nbsp;this&nbsp;module</li>
<li>fileTF=open(‘TF&nbsp;features.txt‘,&nbsp;‘w‘)</li>
<li>numBigClass=len(IndexOfClass.dictClassR_C)-1</li>
<li>for&nbsp;index&nbsp;in&nbsp;range(1,&nbsp;numBigClass&#043;1):&nbsp;&nbsp;#&nbsp;1,&nbsp;numBigClass&#043;1</li>
<li>print&nbsp;‘the&nbsp;‘&#043;str(index)&#043;‘&nbsp;class&nbsp;is&nbsp;processing...‘</li>
<li>fileRujia=open(‘Data_After_Split.txt‘,&nbsp;‘r‘)&nbsp;&nbsp;#open&nbsp;the&nbsp;original&nbsp;Rujia&nbsp;data&nbsp;file</li>
<li>dictTF_IDF={}</li>
<li>wordSum=0&nbsp;&nbsp;#mark&nbsp;the&nbsp;sum&nbsp;of&nbsp;frequency&nbsp;of&nbsp;words,&nbsp;i.e.&nbsp;the&nbsp;denumerator&nbsp;of&nbsp;TF</li>
<li>rowHead=IndexOfClass.dictClassR_C[index]&nbsp;&nbsp;#&nbsp;head&nbsp;row&nbsp;of&nbsp;the&nbsp;index&nbsp;class</li>
<li>rowTail=IndexOfClass.dictClassR_C[index&#043;1]&nbsp;#&nbsp;tail&nbsp;row</li>
<li>for&nbsp;line&nbsp;in&nbsp;fileRujia.readlines()[rowHead-1:rowTail-1]:&nbsp;&nbsp;#&nbsp;within&nbsp;the&nbsp;index&nbsp;class</li>
<li>#print&nbsp;rowHead,&nbsp;rowTail</li>
<li>#print&nbsp;line</li>
<li>for&nbsp;word&nbsp;in&nbsp;line.split():&nbsp;&nbsp;#&nbsp;this&nbsp;FOR&nbsp;loop&nbsp;counts&nbsp;the&nbsp;term&nbsp;times</li>
<li>wordSum&#043;=1</li>
<li>if&nbsp;dictTF_IDF.has_key(word):</li>
<li>dictTF_IDF[word]&#043;=1</li>
<li>else:</li>
<li>dictTF_IDF[word]=1</li>
<li>for&nbsp;word&nbsp;in&nbsp;dictTF_IDF:</li>
<li>dictTF_IDF[word]=1.0*dictTF_IDF[word]/wordSum&nbsp;&nbsp;#&nbsp;to&nbsp;obtain&nbsp;the&nbsp;TF</li>
<li>numDocument=1</li>
<li>for&nbsp;k&nbsp;in&nbsp;range(1,&nbsp;numBigClass&#043;1):&nbsp;&nbsp;#&nbsp;search&nbsp;for&nbsp;the&nbsp;number&nbsp;of&nbsp;big&nbsp;class&nbsp;containing&nbsp;the&nbsp;current&nbsp;word</li>
<li>r1=IndexOfClass.dictClassR_C[k]</li>
<li>r2=IndexOfClass.dictClassR_C[k&#043;1]</li>
<li>#print&nbsp;r1,&nbsp;r2</li>
<li>fileRujia=open(‘Data_After_Split.txt‘,&nbsp;‘r‘)</li>
<li>for&nbsp;line&nbsp;in&nbsp;fileRujia.readlines()[r1-1:r2-1]:</li>
<li>#print&nbsp;line</li>
<li>if&nbsp;word&nbsp;in&nbsp;line.split():</li>
<li>numDocument&#043;=1</li>
<li>#print&nbsp;‘abc‘</li>
<li>break</li>
<li>#print&nbsp;numDocument</li>
<li>dictTF_IDF[word]*=math.log10(1.0*numBigClass/numDocument)&nbsp;#&nbsp;IDF</li>
<li>L=sorted(dictTF_IDF.iteritems(),&nbsp;key=lambda&nbsp;asd:&nbsp;asd[1],&nbsp;reverse=True)</li>
<li>for&nbsp;k&nbsp;in&nbsp;L[0:5]:</li>
<li>fileTF.write(k[0]&#043;‘&nbsp;‘&#043;str(k[1])&#043;‘&nbsp;‘)</li>
<li>fileTF.write(‘\n‘)</li>
</ol>
<p>JAVA版本的程序我也实现了，其中有许多注释和不必要的调试语句。</p>
<p><strong>[java]</strong>&nbsp;<a href="http://blog.csdn.net/puqutogether/article/details/39612655#" rel="external nofollow noreferrer">view<br />
 plain</a><a href="http://blog.csdn.net/puqutogether/article/details/39612655#" rel="external nofollow noreferrer">copy</a></p>
<ol>
<li>import&nbsp;java.io.BufferedReader;</li>
<li>import&nbsp;java.io.File;</li>
<li>import&nbsp;java.io.FileInputStream;</li>
<li>import&nbsp;java.io.FileOutputStream;</li>
<li>import&nbsp;java.io.InputStreamReader;</li>
<li>import&nbsp;java.io.PrintWriter;</li>
<li>import&nbsp;java.util.ArrayList;</li>
<li>import&nbsp;java.util.Collections;</li>
<li>import&nbsp;java.util.Comparator;</li>
<li>import&nbsp;java.util.Iterator;</li>
<li>import&nbsp;java.util.Map.Entry;</li>
<li>import&nbsp;java.util.Scanner;</li>
<li>import&nbsp;java.util.HashMap;</li>
<li>import&nbsp;java.util.List;</li>
<li>import&nbsp;java.util.Arrays;</li>
<li>public&nbsp;class&nbsp;demo&nbsp;{</li>
<li>/**</li>
<li>*&nbsp;@param&nbsp;args</li>
<li>*/</li>
<li>public&nbsp;static&nbsp;void&nbsp;main(String[]&nbsp;args)&nbsp;throws&nbsp;Exception{</li>
<li>//&nbsp;TODO&nbsp;Auto-generated&nbsp;method&nbsp;stub</li>
<li>//&nbsp;TODO&nbsp;Auto-generated&nbsp;method&nbsp;stub</li>
<li>java.io.File&nbsp;oriDataFile=new&nbsp;java.io.File(&quot;originalData.txt&quot;);&nbsp;//读取文件</li>
<li>java.io.File&nbsp;classIndexFile=new&nbsp;java.io.File(&quot;smallClassIndex.txt&quot;);</li>
<li>if(!oriDataFile.exists()&nbsp;&amp;&amp;&nbsp;!classIndexFile.exists()){</li>
<li>System.out.println(&quot;&nbsp;inputFile&nbsp;does&nbsp;not&nbsp;exist...&quot;);</li>
<li>System.exit(0);</li>
<li>}</li>
<li>Scanner&nbsp;inputData=new&nbsp;Scanner(oriDataFile);</li>
<li>Scanner&nbsp;inputIndex=new&nbsp;Scanner(classIndexFile);</li>
<li>int&nbsp;totalClassNum=0;&nbsp;&nbsp;&nbsp;//小类的类别数</li>
<li>int&nbsp;a[]=new&nbsp;int[1000];</li>
<li>while&nbsp;(inputIndex.hasNext()){</li>
<li>a[totalClassNum&#043;&#043;]=inputIndex.nextInt();&nbsp;&nbsp;&nbsp;&nbsp;//存储每个小类的行号，最后一个无用</li>
<li>}</li>
<li>//&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;System.out.println(totalClassNum);</li>
<li>java.io.File&nbsp;featureFile=new&nbsp;java.io.File(&quot;TFIDFFeatures.txt&quot;);</li>
<li>java.io.PrintWriter&nbsp;output&nbsp;=&nbsp;new&nbsp;java.io.PrintWriter(featureFile);</li>
<li>for(int&nbsp;k=0;&nbsp;k&lt;totalClassNum-1;&nbsp;k&#043;&#043;){&nbsp;&nbsp;//循环遍历每个小类&nbsp;&nbsp;&nbsp;totalClassNum-1</li>
<li>//&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;System.out.println(totalClassNum);</li>
<li>System.out.println(&quot;The&nbsp;&quot;&#043;(k&#043;1)&#043;&quot;&nbsp;class&nbsp;is&nbsp;processing&nbsp;...&quot;);</li>
<li>int&nbsp;headLine=a[k];&nbsp;&nbsp;//当前小类起始行</li>
<li>int&nbsp;tailLine=a[k&#043;1];//终止行</li>
<li>int&nbsp;numLine=tailLine-headLine;</li>
<li>//&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;System.out.println(numLine);</li>
<li>//---------------------TF&nbsp;Features-------------------------//</li>
<li>//&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;可以统计当前类中每个word出现的次数，TF</li>
<li>System.out.println(&quot;The&nbsp;TF&nbsp;features&nbsp;are&nbsp;extracting&nbsp;...&quot;);</li>
<li>HashMap&lt;String,&nbsp;Integer&gt;&nbsp;wordMap=new&nbsp;HashMap&lt;String,&nbsp;Integer&gt;();</li>
<li>int&nbsp;totalCount=0;</li>
<li>for(int&nbsp;i=0;&nbsp;i&lt;numLine;&nbsp;i&#043;&#043;){</li>
<li>String&nbsp;str=inputData.nextLine();&nbsp;&nbsp;//提取每一行</li>
<li>//&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;System.out.println(str);</li>
<li>String[]&nbsp;strArray=str.split(&quot;&nbsp;&quot;);&nbsp;&nbsp;//按空&#26684;切割</li>
<li>totalCount&#043;=strArray.length;</li>
<li>for(int&nbsp;j=0;&nbsp;j&lt;strArray.length;&nbsp;j&#043;&#043;){</li>
<li>//&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;System.out.println(strArray[j]);</li>
<li>if(!wordMap.containsKey(strArray[j])){&nbsp;&nbsp;//如果不存在，添加</li>
<li>wordMap.put(strArray[j],&nbsp;1);</li>
<li>}</li>
<li>else{&nbsp;&nbsp;//如果已存在，count&#043;1</li>
<li>int&nbsp;v=wordMap.get(strArray[j]);</li>
<li>wordMap.put(strArray[j],&nbsp;v&#043;1);</li>
<li>}</li>
<li>}</li>
<li>}</li>
<li>//&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;System.out.println(totalCount);</li>
<li>HashMap&lt;String,&nbsp;Double&gt;&nbsp;tfMap=new&nbsp;HashMap&lt;String,&nbsp;Double&gt;();</li>
<li>Iterator&nbsp;it=wordMap.keySet().iterator();</li>
<li>while&nbsp;(it.hasNext()){</li>
<li>String&nbsp;key=(String)&nbsp;it.next();</li>
<li>int&nbsp;v=wordMap.get(key);</li>
<li>tfMap.put(key,&nbsp;1.0*v/totalCount);&nbsp;&nbsp;//TF&nbsp;Map</li>
<li>//&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;System.out.println(key&#043;1.0*v/totalCount);</li>
<li>}</li>
<li>//---------------------IDF&nbsp;Features----------------------//</li>
<li>System.out.println(&quot;The&nbsp;IDF&nbsp;features&nbsp;are&nbsp;extracting&nbsp;...&quot;);</li>
<li>HashMap&lt;String,&nbsp;Double&gt;&nbsp;idfMap=new&nbsp;HashMap&lt;String,&nbsp;Double&gt;();</li>
<li>Iterator&nbsp;it1=wordMap.keySet().iterator();</li>
<li>while&nbsp;(it1.hasNext()){</li>
<li>String&nbsp;key=(String)&nbsp;it1.next();&nbsp;&nbsp;//取当前word</li>
<li>//&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;System.out.println(&quot;Searching&nbsp;for&nbsp;&quot;&#043;key);</li>
<li>//在其余小类中查找是否出现过key</li>
<li>int&nbsp;otherClassNum=1;&nbsp;&nbsp;//记录每个word在其他类出现的次数</li>
<li>for&nbsp;(int&nbsp;m=0;&nbsp;m&lt;totalClassNum-1;&nbsp;m&#043;&#043;){&nbsp;&nbsp;//遍历所有的类&nbsp;totalClassNum-1</li>
<li>int&nbsp;beginning=a[m];&nbsp;&nbsp;&nbsp;//当前其他类的起始行</li>
<li>int&nbsp;ending=a[m&#043;1];&nbsp;&nbsp;&nbsp;//终止行</li>
<li>//&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;System.out.println(beginning);</li>
<li>//&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;System.out.println(ending);</li>
<li>InputStreamReader&nbsp;I=new&nbsp;InputStreamReader(new&nbsp;FileInputStream(&quot;originalData.txt&quot;),&nbsp;&quot;gbk&quot;);&nbsp;&nbsp;//编码是gbk,不过最好统一为utf-8</li>
<li>BufferedReader&nbsp;sr&nbsp;=&nbsp;new&nbsp;BufferedReader(I);</li>
<li>String&nbsp;txt=sr.readLine();&nbsp;&nbsp;&nbsp;//readLine读取一行，字符串</li>
<li>int&nbsp;next=1;&nbsp;//记录读取的行数</li>
<li>while(txt!=null){</li>
<li>if(next&gt;=beginning-1&nbsp;&amp;&amp;&nbsp;next&lt;ending){&nbsp;&nbsp;//一定要在当前其他类才好判断</li>
<li>//&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;System.out.println(txt);</li>
<li>String&nbsp;[]str2Array=txt.split(&quot;&nbsp;&quot;);</li>
<li>int&nbsp;l;</li>
<li>for&nbsp;(l=0;&nbsp;l&lt;str2Array.length;&nbsp;l&#043;&#043;){</li>
<li>if(str2Array[l].equals(key)){</li>
<li>//&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;System.out.println(&quot;Find&nbsp;&quot;&#043;key);&nbsp;&nbsp;//输出找到</li>
<li>otherClassNum&#043;&#043;;</li>
<li>break;&nbsp;&nbsp;//跳出while该类的判断，期待</li>
<li>}</li>
<li>}</li>
<li>if(l&lt;str2Array.length)&nbsp;&nbsp;//说明已经找到</li>
<li>break;&nbsp;//break出while循环</li>
<li>}</li>
<li>txt=sr.readLine();&nbsp;//继续读取下一个问题</li>
<li>next&#043;&#043;;</li>
<li>}</li>
<li>}</li>
<li>//&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;System.out.println(key&#043;&quot;appears&nbsp;&quot;&#043;otherClassNum&#043;&quot;&nbsp;times&quot;);&nbsp;&nbsp;//输出当前word在其他类当中出现的次数</li>
<li>idfMap.put(key,&nbsp;Math.log10(1.0*(totalClassNum-1)/otherClassNum));</li>
<li>//&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;System.out.println(Math.log10(1.0*(totalClassNum-1)/otherClassNum));</li>
<li>}</li>
<li>//-----------TF和IDF特征的融合，并排序，取每个小类的前五名-----------------//</li>
<li>HashMap&lt;String,&nbsp;Double&gt;&nbsp;tfIdfMap=new&nbsp;HashMap&lt;String,&nbsp;Double&gt;();</li>
<li>//&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Iterator&nbsp;it1=tfIdfMap.keySet().iterator();</li>
<li>Iterator&nbsp;it2=tfMap.keySet().iterator();</li>
<li>Iterator&nbsp;it3=idfMap.keySet().iterator();</li>
<li>while(it2.hasNext()&nbsp;&amp;&amp;&nbsp;it3.hasNext()){</li>
<li>String&nbsp;key1=(String)&nbsp;it2.next();</li>
<li>String&nbsp;key2=(String)&nbsp;it3.next();</li>
<li>Double&nbsp;v=tfMap.get(key1)*idfMap.get(key2);&nbsp;&nbsp;//tf*idf</li>
<li>tfIdfMap.put(key1,&nbsp;v);&nbsp;&nbsp;//idfTfMap</li>
<li>}</li>
<li>//排序</li>
<li>List&lt;Entry&lt;String,&nbsp;Double&gt;&gt;&nbsp;infoIds&nbsp;=</li>
<li>new&nbsp;ArrayList&lt;Entry&lt;String,&nbsp;Double&gt;&gt;(tfIdfMap.entrySet());</li>
<li>Collections.sort(infoIds,&nbsp;new&nbsp;Comparator&lt;Entry&lt;String,&nbsp;Double&gt;&gt;()&nbsp;{</li>
<li>public&nbsp;int&nbsp;compare(Entry&lt;String,&nbsp;Double&gt;&nbsp;o1,&nbsp;Entry&lt;String,&nbsp;Double&gt;&nbsp;o2)&nbsp;{</li>
<li>if(o2.getValue()&nbsp;-&nbsp;o1.getValue()&gt;0){</li>
<li>return&nbsp;1;</li>
<li>}</li>
<li>return&nbsp;-1;</li>
<li>//return&nbsp;(int)(o2.getValue()&nbsp;-&nbsp;o1.getValue());</li>
<li>//&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;return&nbsp;(o1.getKey()).toString().compareTo(o2.getKey());</li>
<li>}</li>
<li>});</li>
<li>int&nbsp;selectNum;</li>
<li>if(infoIds.size()&lt;5){&nbsp;&nbsp;//防止有些小类问题数量少</li>
<li>selectNum=infoIds.size();</li>
<li>}</li>
<li>else</li>
<li>selectNum=5;</li>
<li>for&nbsp;(int&nbsp;q=0;&nbsp;q&lt;selectNum;&nbsp;q&#043;&#043;){&nbsp;&nbsp;//只取前五名</li>
<li>String&nbsp;id&nbsp;=&nbsp;infoIds.get(q).toString();</li>
<li>//&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;System.out.println(id);</li>
<li>int&nbsp;equalIndex=id.indexOf(‘=‘);</li>
<li>char&nbsp;[]strChar=id.toCharArray();</li>
<li>String&nbsp;fea=new&nbsp;String();</li>
<li>for&nbsp;(int&nbsp;d=0;&nbsp;d&lt;equalIndex;&nbsp;d&#043;&#043;){</li>
<li>fea=fea&#043;strChar[d];</li>
<li>}</li>
<li>System.out.println(fea);</li>
<li>output.print(fea);</li>
<li>output.print(‘&nbsp;‘);</li>
<li>}</li>
<li>output.print(‘\n‘);</li>
<li>System.out.println(&quot;The&nbsp;&quot;&#043;(k&#043;1)&#043;&quot;&nbsp;class&nbsp;ends...&quot;);</li>
<li>}</li>
<li>output.close();&nbsp;&nbsp;//close&nbsp;输出的文件</li>
<li>}</li>
<li>}</li>
</ol>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-29 23:09:53 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/python/" title="python">python</a>, <a href="https://www.biecuoliao.com/tag/%e7%ae%97%e6%b3%95/" title="算法">算法</a>, <a href="https://www.biecuoliao.com/tag/nlp/" title="nlp">nlp</a>, <a href="https://www.biecuoliao.com/tag/tf-idf/" title="tf-idf">tf-idf</a>, <a href="https://www.biecuoliao.com/tag/%e6%96%87%e6%9c%ac%e7%89%b9%e5%be%81%e6%8f%90%e5%8f%96/" title="文本特征提取">文本特征提取</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>TF-IDF算法及其编程实现的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0eAnYg0.html" rel="bookmark">tf&ndash;idf算法解释及其python代码实现&lpar;下&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				tf–idf算法python代码实现 这是我写的一个tf-idf的核心部分的代码,没有完整实现,当然剩下的事情就非常简单了,我们知道tfidf=tf*idf,所以可以分别计算tf和idf值在相乘,首先我们创建一个简单的语料库,作为例子,只有四句话,每句表示一个文档 copus=['我正在学习计算机','它正在吃饭','我的书还在你那儿','今天不上班'] 由于中文需要分词,jieba分词是python里面比较好用的分词工具,所以选用jieba分词,文末是jieba的链接.首先对文档进行分词: i			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4JkQDQM.html" rel="bookmark">tf&ndash;idf算法解释及其python代码实现&lpar;上&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				tf–idf算法解释 tf–idf, 是term frequency–inverse document frequency的缩写,它通常用来衡量一个词对在一个语料库中对它所在的文档有多重要,常用在信息检索和文本挖掘中. 一个很自然的想法是在一篇文档中词频越高的词对这篇文档越重要,但同时如果这个词又在非常多的文档中出现的话可能就是很普通的词,没有多少信息,对所在文档贡献不大,例如‘的’这种停用词.所以要综合一个词在所在文档出现次数以及有多少篇文档包含这个词,如果一个词在所在文档出现次数很多同时整个			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Movq9y4.html" rel="bookmark">55&period;TF&sol;IDF算法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				主要知识点: TF/IDF算法介绍 查看es计算_source的过程及各词条的分数 查看一个document是如何被匹配到的 一.算法介绍 relevance score算法,简单来说,就是计算出,一个索引中的文本,与搜索文本,他们之间的关联匹配程度.Elasticsearch使用的是 term frequency/inverse document frequency算法,简称为TF/IDF算法 1.Term frequency 搜索文本中的各个词条在field文本中出现了多少次,出现次数越多,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4Aeeky4.html" rel="bookmark">25&period;TF&amp;IDF算法以及向量空间模型算法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				主要知识点: boolean model IF/IDF vector space model 一.boolean model 在es做各种搜索进行打分排序时,会先用boolean model 进行初步的筛选,boolean model类似and这种逻辑操作符,先过滤出包含指定term的doc.must/must not/should(过滤.包含.不包含 .可能包含)这几种情况,这一步不会对各个doc进行打分,只分过滤,为下一步的IF/IDF算法筛选数据. 二.TF/IDF 这一步就是es为boo			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/38bbJAM.html" rel="bookmark">Elasticsearch学习之相关度评分TF&amp;amp&semi;IDF</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				relevance score算法,简单来说,就是计算出,一个索引中的文本,与搜索文本,他们之间的关联匹配程度 Elasticsearch使用的是 term frequency/inverse document frequency算法,简称为TF/IDF算法 Term frequency(TF):搜索文本中的各个词条在field文本中出现了多少次,出现次数越多,就越相关 Inverse document frequency(IDF):搜索文本中的各个词条在整个索引的所有文档中出现了多少次,出现的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3rKXv94.html" rel="bookmark">文本分类学习（三） 特征权重（TF&sol;IDF）和特征提取</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				上一篇中,主要说的就是词袋模型.回顾一下,在进行文本分类之前,我们需要把待分类文本先用词袋模型进行文本表示.首先是将训练集中的所有单词经过去停用词之后组合成一个词袋,或者叫做字典,实际上一个维度很大的向量.这样每个文本在分词之后,就可以根据我们之前得到的词袋,构造成一个向量,词袋中有多少个词,那这个向量就是多少维度的了.然后就把这些向量交给计算机去计算,而不再需要文本啦.而向量中的数字表示的是每个词所代表的权重.代表这个词对文本类型的影响程度. 在这个过程中我们需要解决两个问题:1.如何计算出适			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MWwRgLM.html" rel="bookmark">&lbrack;Elasticsearch&rsqb; 控制相关度 &lpar;四&rpar; - 忽略TF&sol;IDF</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本章翻译自Elasticsearch官方指南的Controlling Relevance一章. 忽略TF/IDF 有时我们不需要TF/IDF.我们想知道的只是一个特定的单词是否出现在了字段中.比如我们正在搜索度假酒店,希望它拥有的卖点越多越好: WiFi 花园(Garden) 泳池(Pool) 而关于度假酒店的文档类似下面这样: { &quot;description&quot;: &quot;A delightful four-bedroomed house with ... &quot; } 可以使用			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MmA1VKM.html" rel="bookmark">关于使用Filter减少Lucene tf idf打分计算的调研</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				将query改成filter,lucene中有个QueryWrapperFilter性能比较差,所以基本上都需要自己写filter,包括TermFilter,ExactPhraseFilter,ConjunctionFilter,DisjunctionFilter. 这几天验证下来,还是or改善最明显,4个termfilter,4508个返回结果,在我本机上性能提高1/3.ExactPhraseFilter也有小幅提升(5%-10%). 最令人不解的是and,原来以为跟结果数和子查询数相关,但几			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0agJzQ4.html" rel="bookmark">机器学习算法与编程实践之中文文本分类</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这周学习了机器学习算法与编程实践第二章--中文文本分类的部分内容.该章以文本挖掘为大背景,以文本分类算法为中心,详细介绍了中文文本分类项目的相关知识点. 一.文本挖掘与文本分类的概念 被普遍认可的文本挖掘的定义如下:文本挖掘是指从大量文本数据中抽取事先未知的.可理解的.最终可用的知识的过程,同时运用这些知识更好的组织信息以便将来参考. 文本挖掘的7个主要领域有:(1)搜索和信息检索,(2)文本聚类,(3)文本分类,(4)Web挖掘.(5)信息抽取,(6)自然语言处理,(7)概念提取. 而文本分类			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/V02Y5RM.html" rel="bookmark" class="title">hdu5396 Expression</a>
					<div>
						Expression Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others)Total  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPdbVPM.html" rel="bookmark" class="title">EF-CodeFirst-2玩的嗨</a>
					<div>
						时间戳.复杂类型.GUID自增长 GUID自增长 GUID用于当主建那是好处多多,但是和int不同.EF不会自动识别第一个为类名+Id开头或int类型字段 去设置自增长.尴尬的GUID怎么玩呢.. D ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3r27573.html" rel="bookmark" class="title">call和apply的使用</a>
					<div>
						call和apply的用途 1.传递参数 call和apply的第一个参数都是待绑定的对象,第二个参数有差别 //call使用的参数是可变参数 //apply使用的参数是数组 function sum ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoGagyM.html" rel="bookmark" class="title">lunux多线程编程</a>
					<div>
						1.进程与线程 1)用户空间角度: 进程:fork()创建进程,在创建时,重新申请了内存空间,copy了父进程的所有信息. 线程:pthread_create()创建进程时,只申请自己的栈空间. 2) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzQ6W84.html" rel="bookmark" class="title">Jetty 9&period;3庆祝20周年生日快乐，并添加HTTP&sol;2支持</a>
					<div>
						本文来源于我在InfoQ中文站翻译的文章,原文地址是:http://www.infoq.com/cn/news/2015/06/Building-Distributed-Systems 今年6月12日 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzQbpO4.html" rel="bookmark" class="title">【链表】Add Two Numbers</a>
					<div>
						题目: You are given two linked lists representing two non-negative numbers. The digits are stored in r ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0aOk2n4.html" rel="bookmark" class="title">计算机的有哪些部分组成和什么是ip</a>
					<div>
						一 计算机的组成 现代的计算机创始人之一 冯·诺依曼(John von Neumann,1903~1957),出生于匈牙利的美国籍犹太人数学家,现代计算机创始人之一,被称为&quot;计算机之父&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDvvBk3.html" rel="bookmark" class="title">使用WindowManager添加自定义视图</a>
					<div>
						原文地址:使用WindowManager添加自定义视图 在写手机卫士的时候,用户拨打|接听电话需要显示号码归属地,然后出现了一些异常,在此留下记号,希望对麻友们有帮助: BUG教程 在使用 view  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ORxno0.html" rel="bookmark" class="title">堆算法简介</a>
					<div>
						堆是有特殊顺序的完全二叉树.常用数组存储. 以最小堆为例.其父节点,要小于左右两个子节点.如此递归定义. 数组存储.第i个节点的父节点是 (i-1)/2, 左子节点是2*i+1, 右子节点是2*i+2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xvWnn4.html" rel="bookmark" class="title">使用inno setup打包程序完整脚本&lpar;&period;net框架检测&comma;重复安装检测&rpar;</a>
					<div>
						; 脚本由 Inno Setup 脚本向导 生成!; 有关创建 Inno Setup 脚本文件的详细资料请查阅帮助文档! #define MyAppName &quot;小小鸟软件&quot;#def ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41oY9Y0.html" rel="bookmark" class="title">J2EE（二）&mdash; JDBC</a>
					<div>
						JDBC JDBC (Java Data Base Connectivity,Java数据库连接)是一种用于执行SQL语句的Java API. 看到Java数据库连接,只要是从vb及.NET学过来的, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pQxRKM.html" rel="bookmark" class="title">电子商务系统一体化</a>
					<div>
						随着电子商务在这几年的快速发展,企业这种分离使用ERP和电子商务的状况已经开始遭遇发展瓶颈.企业在电子商务中积累的越来越多的市场信息处于游离状态:由于企业参与全球竞争的残酷性,企业现有的响应速度不能为 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzLpn23.html" rel="bookmark" class="title">《30天自制操作系统》笔记&lpar;03&rpar;&mdash;&mdash;使用Vmware</a>
					<div>
						&lt;30天自制操作系统&gt;笔记(03)--使用Vmware 进度回顾 在上一篇,实现了用IPL加载OS程序到内存,然后JMP到OS程序这一功能:并且总结出下一步的OS开发结构.但是遇到了真机测 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pPePw4.html" rel="bookmark" class="title">windows命令行（DOS批处理）添加任务计划</a>
					<div>
						转自:http://gwmold.blog.163.com/blog/static/1553319892010117113457232/ 自动创建每周运行一次的计划任务 创建计划任务可用at,scht ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rb9nX3.html" rel="bookmark" class="title">Unity iPhone6适配</a>
					<div>
						Unity 4.5.4f1是不适配iPhone 6 的,从Unity 4.5.4p1的Release Notes可以看出来. 但是4.5.4p1是在9月18号放出来的.我们在这之前就要做iOS 8 i ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0jr1mo0.html" rel="bookmark" class="title">POJ2676 Sudoku &lbrack;数独&rsqb;</a>
					<div>
						好题,也很实用,犯了几个错误 1.在枚举赋值的时候,思维有个错误:当当前的赋值不能填完这个数独,应该是继续下一个循环,而不是return false 终止枚举 2.Generic Programing ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xeo673.html" rel="bookmark" class="title">Installing MySQL on Microsoft Windows Using a noinstall Zip Archive</a>
					<div>
						这两天在自己的windows7上安装了一下MySQL数据库,安装使用的是5.7.18版本的 noinstall Zip Archive安装包mysql-5.7.18-win32.zip.由于5.7版本 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Aajnv4.html" rel="bookmark" class="title">把之前写的一个小东西代码分享出来</a>
					<div>
						大家接触到流的输出输入和GUI就会自己写了,其实soeasy 所以不好意思拿出来,毕竟是小白,主要还是因为懒,FileDialog也懒得弄了,讲道理界面太丑,加了dialog也挺low,自己想留着用的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pgpwR3.html" rel="bookmark" class="title">sublime添加到鼠标右键打开文件的方法？</a>
					<div>
						步骤: 1.win+R 打开运行,并输入regedit. 2.在左侧依次打开HKEY_CLASSES_ROOT\*\shell 3.在shell下新建&quot;Sublime Text&quot;项 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YL6kqM.html" rel="bookmark" class="title">AC日记&mdash;&mdash;合法C标识符 openjudge 1&period;7 06</a>
					<div>
						06:合法 C 标识符 总时间限制:  1000ms 内存限制:   65536kB 描述 给定一个不包含空白符的字符串,请判断是否是C语言合法的标识符号(注:题目保证这些字符串一定不是C语言的保留字 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 11 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
